/*
 * lab0.c
 *
 */


#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <stdio.h>

#define MORSE_LUNG 3
#define MORSE_SCURT 1

/* pini_D[4] = led rosu */
/* pini_D[5] = led verde */
/* pini_D[6] = led albastru */

int pini_C[8] = {PC0, PC1, PC2, PC3, PC4, PC5, PC6, PC7};
int pini_B[5] = {PB0, PB1, PB2, PB3, PB4};
int pini_D[7] = {PD2, PD1, PD0, PD3, PD4, PD5, PD6};



/* aprinde led-ul PC0 la apasarea butonului PB0 */
void exemplu() {

	int i;
	
	int vector[8];
	/* setez pinii PC0 - PC7 ca intrare */
	for (i = 0; i < 8; i++)
	{
		DDRC &= ~(1 << pini_C[i]);
		PORTC &= ~(1 << pini_C[i]);
	}
	/* activez rezistenta de pull-up pentru pinul PB0*/
	//PORTB |= (1 << PB0);

	/* setez pinii PB0 - PB4, PD0 - PD6 ca iesire */
	for (i = 0; i < 5; i++)
		DDRB |= (1 << pini_B[i]);
	for (i = 0; i < 7; i++)
		DDRD |= (1 << pini_D[i]);
	
	/* opresc toate led-urile */
	for (i = 0; i < 5; i++)
		PORTB &= ~(1 << pini_B[i]);
	for (i = 0; i < 3; i++)
		PORTD &= ~(1 << pini_D[i]);
	for (i = 4; i < 7; i++)
		PORTD |= (1 << pini_D[i]);
	
	/* ledul RGB are anod comun => pun HIGH pe pinul corespunzator */
	/*	PORTD |= (1 << pini_D[3]);*/
	
	/* opresc LED-ul pe de pinul PC0 */
	//PORTD &= ~(1 << PD7);
	
	/* trimit semnal pe firul 1 */
	/*PORTB |= (1 << pini_B[0]);
	for (i = 0; i < 8; i++)
		if ((PINC & (1 << pini_C[i])) == 0)
			break;
	_delay_ms(1000);
	if (i == 8)
	{
		/* aprind led rosu 
		PORTD &= ~(1 << pini_D[4]);
		while (1);
	} else
		vector[0] = i;
	
	PORTB &= ~(1 << pini_B[0]); */
	
	
}
	
	/* verific */
	
	
	
	


void test() {
	
	/* setez pinul PB0 ca iesire */
	DDRB |= (1 << PB0);
	
	/* setez pinul PD0 ca intrare */
	DDRD &= ~(1 << PD0);
	
	/* setez "1" pe PB0 */
	PORTB |= (1 << PB0);
	
	if ((PIND & (1 << PD0)) == 0)
	{
		PORTD |= (1 << PD7);
		_delay_ms(3000);
		PORTD &= ~(1 << PD7);
	}
		

	/* setez "0" pe PB0 */
	PORTB &= ~(1 << PB0);
}


/* TODO 1 - generare secvente aprindere LED-uri */
void task1() {
	/* Setare directii porturi folosite */
	
	while(1) {
		
		/*	Generare secvente pentru PB1 si PB0	*/
		
	}
}


/* TODO 2 - cod morse folosind speaker */
void task2() {
	/* Setare directii porturi folosite	*/
	
	while (1) {
		
		/*	Generare cod morse pentru PB1 si PB0 */
		
	}
}

/* TODO 2 - genereaza sunetul pentru tipul de cod folosit: lung sau scurt */
void speaker_morse(int tip_morse) {
	
	/* se va alterna starea portului PD5 la intervale de timp foarte mici */
	
}


/* TODO 3 - implementati afisarea secventei morse si pentru LED-uri
 * mai exact, codul scurt e un LED aprins, codul lung e de 3 LED-uri aprinse
 * iar pauza intre ele este mereu 1 LED
 * se poate face si analogia: un LED inseamna delay de 50 ms
 */
void task3() {
	/* Setare directii porturi folosite	*/
	
	while (1) {
		
		/*	Generare cod morse pentru PB1 si PB0 */
		
	}
}

/* TODO 3 - aprinde LED-urile corespunzatoare codului
 *	si shifteaza secventa anterioara la stanga
 */
void leduri(int tip_morse) {
	
}


int main(void) {
	//exemplu();
	//test();
	//task1();
	//task2();
	//task3();
	int vector[8], i;
	
	DDRB |= (1 << PB0);
	DDRB |= (1 << PB1);
	DDRB |= (1 << PB2);
	DDRB |= (1 << PB3);
	DDRB |= (1 << PB4);
	DDRD |= (1 << PD2);
	DDRD |= (1 << PD1);
	DDRD |= (1 << PD0);
	DDRD |= (1 << PD3);
	DDRD |= (1 << PD4);
	DDRD |= (1 << PD5);
	DDRD |= (1 << PD6);
	
	PORTB &= ~(1 << PB1);
	PORTB &= ~(1 << PB2);
	PORTB &= ~(1 << PB3);
	PORTB &= ~(1 << PB4);
	PORTD &= ~(1 << PD2);
	PORTD &= ~(1 << PD1);
	PORTD &= ~(1 << PD0);
	PORTD |= (1 << PD5);
	PORTD |= (1 << PD6);
	PORTD |= (1 << PD4);
	
	PORTD |= (1 << PD3); /* anod comun led RGB */
	
	for (i = 0; i < 8; i++)
		DDRC &= ~(1 << pini_C[i]);
	
	while(1){
	
	
	
	
	PORTB |= (1 << PB0);
	for (i = 0; i < 8; i++)
		if ((PINC & (1 << pini_C[i])) == 0)
		{
			
			vector[0] = i;
			break;
		}
	_delay_ms(1000);
	PORTB &= ~(1 << PB0);
	
	
	PORTB |= (1 << PB1);
	for (i = 0; i < 8; i++)
		if ((PINC & (1 << pini_C[i])) == 0)
		{
			
			vector[1] = i;
			break;
		}
	_delay_ms(1000);
	PORTB &= ~(1 << PB1);
	
	PORTB |= (1 << PB2);
	for (i = 0; i < 8; i++)
		if ((PINC & (1 << pini_C[i])) == 0)
		{
			
			PORTD |= (1 << PD6);
			vector[2] = i;
			break;
		}
	_delay_ms(1000);
	PORTB &= ~(1 << PB2);
	
	PORTB |= (1 << PB3);
	for (i = 0; i < 8; i++)
		if ((PINC & (1 << pini_C[i])) == 0)
		{
			
			vector[3] = i;
			break;
		}
	_delay_ms(1000);
	PORTB &= ~(1 << PB3);
	
	PORTB |= (1 << PB4);
	for (i = 0; i < 8; i++)
		if ((PINC & (1 << pini_C[i])) == 0)
		{
			
			vector[4] = i;
			break;
		}
	_delay_ms(1000);
	PORTB &= ~(1 << PB4);
	
	PORTD |= (1 << PD2);
	for (i = 0; i < 8; i++)
		if ((PINC & (1 << pini_C[i])) == 0)
		{
			
			vector[5] = i;
			break;
		}
	_delay_ms(1000);
	PORTD &= ~(1 << PD2);
	
	PORTD |= (1 << PD1);
	for (i = 0; i < 8; i++)
		if ((PINC & (1 << pini_C[i])) == 0)
		{
			
			vector[6] = i;
			break;
		}
	_delay_ms(1000);
	PORTD &= ~(1 << PD1);
	
	PORTD |= (1 << PD0);
	for (i = 0; i < 8; i++)
		if ((PINC & (1 << pini_C[i])) == 0)
		{
			vector[7] = i;
			break;
		}
	_delay_ms(1000);
	PORTD &= ~(1 << PD0);
	
	for (i = 0; i < 8; i++)
		if (vector[i] != i)
			break;
		if ((vector[0] == 0) && (vector[1] == 0) && (vector[2] == 0) && (vector[3] == 0) 
		&& (vector[4] == 0) && (vector[5] == 0) && (vector[6] == 0) && (vector[7] == 0))
			{
				PORTD &= ~(1 << PD5);
				_delay_ms(1000);
				PORTD |= (1 << PD5);
			}
			
	
	
	
		}
		
	return 0;
}

